PUB Sec(delay) | ticks, delayTicks
{{
  Shorthand to delay for 'delay' number of seconds.  Do not supply value
  larger than 52 seconds.
}}
  ticks := clkfreq

  delayTicks := cnt
  delayTicks += (ticks * delay) - 1116
  
  waitcnt(delayTicks)

PUB mSec(delay) | ticks, delayTicks
{{
  Shorthand to delay for 'delay' number of milliseconds
}}
  ticks := clkfreq/1_000

  delayTicks := (ticks * delay)-3820
  waitcnt(delayTicks+cnt)

PUB uSec(delay) | ticks, delayTicks
{{
  Shorthand to delay for 'delay' number of microseconds.
  
  Can't go below:
  62  uSecs @ 80MHz
  125 uSecs @ 40Mhz
  250 uSecs @ 20Mhz
  500 uSecs @ 10Mhz
  Not Useable @ 5 MHz

  We only enforce the floor for 80MHz.
}}
  ticks := clkfreq/1_000_000

  if delay < 62
    delay := 62
    delayTicks := (ticks * delay) - 4804
    waitcnt(delayTicks+cnt)
    return
  
  delayTicks := (ticks * delay) - 4512
  waitcnt(delayTicks+cnt)
  